## netdata 1.47.2

=== CMakeLists.txt ===
# SPDX-License-Identifier: GPL-3.0-or-later

cmake_minimum_required(VERSION 3.16.0...3.30)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/packaging/cmake/Modules")

include(NetdataVersion)
netdata_version()

project(netdata
        VERSION "${NETDATA_VERSION_MAJOR}.${NETDATA_VERSION_MINOR}.${NETDATA_VERSION_PATCH}.${NETDATA_VERSION_TWEAK}"
        HOMEPAGE_URL "https://www.netdata.cloud"
        LANGUAGES C CXX)
include(CMakeDependentOption)

if(DEFINED BUILD_SHARED_LIBS)
    if(NOT BUILD_SHARED_LIBS)
        set(STATIC_BUILD TRUE)
    endif()
endif()

if(STATIC_BUILD)
    set(CMAKE_FIND_LIBRARY_PREFIXES "${CMAKE_STATIC_LIBRARY_PREFIX}")
    set(CMAKE_FIND_LIBRARY_SUFFIXES "${CMAKE_STATIC_LIBRARY_SUFFIX}")
endif()

find_package(PkgConfig REQUIRED)

if(STATIC_BUILD)
    list(APPEND PKG_CONFIG_EXECUTABLE "--static")
endif()

set(CMAKE_C_STANDARD 11)
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_INSTALL_DEFAULT_COMPONENT_NAME "netdata")

option(USE_CXX_11 "Use C++11 instead of C++14 (should only be used on legacy systems that cannot support C++14, may disable some features)" False)
mark_as_advanced(USE_CXX_11)

if(USE_CXX_11)
    set(CMAKE_CXX_STANDARD 11)
endif()

set(CMAKE_C_STANDARD_REQUIRED On)
set(CMAKE_CXX_STANDARD_REQUIRED On)

set(SIZEOF_VOID_P ${CMAKE_SIZEOF_VOID_P})

if(NOT CMAKE_BUILD_TYPE)
        set(CMAKE_BUILD_TYPE "Release")
endif()

include(NetdataCompilerFlags)

set(CMAKE_EXPORT_COMPILE_COMMANDS On)

# Check for the mold linker and try to use it if available
option(USE_MOLD "If the MOLD linker is available on the system, use it instead of the default linker." TRUE)

if(USE_MOLD)
        message(CHECK_START "Searching for MOLD linker")
        find_program(MOLD_LINKER NAMES ld.mold mold)

        if(MOLD_LINKER)
                execute_process(COMMAND ${MOLD_LINKER} --version
                                RESULT_VARIABLE MOLD_VERSION_RESULT
                                OUTPUT_VARIABLE MOLD_VERSION)

                if(NOT MOLD_VERSION_RESULT)
                        string(REPLACE "\n" "" MOLD_VERSION "${MOLD_VERSION}")
                        message(CHECK_PASS "found (version: ${MOLD_VERSION})")
                        message(STATUS "Using mold instead of the system default for linking.")
                        add_link_options("-fuse-ld=mold")
                else()
                        message(CHECK_FAIL "failed")
                endif()
        else()
                message(CHECK_FAIL "failed")
        endif()
endif()

set(CONFIG_H_DIR ${CMAKE_BINARY_DIR})
set(CONFIG_H ${CONFIG_H_DIR}/config.h)

#
# detect OS
#

set(OS_FREEBSD     False)
set(OS_LINUX       False)
set(OS_MACOS       False)
set(OS_WINDOWS     False)

set(NETDATA_RUNTIME_PREFIX "${CMAKE_INSTALL_PREFIX}")
set(BINDIR usr/sbin)

if("${CMAKE_SYSTEM_NAME}" STREQUAL "Darwin")
        set(OS_MACOS True)
        find_library(IOKIT IOKit)
        find_library(FOUNDATION Foundation)
        message(STATUS " Compiling for MacOS... ")
elseif("${CMAKE_SYSTEM_NAME}" STREQUAL "FreeBSD")
        set(OS_FREEBSD True)
        message(STATUS " Compiling for FreeBSD... ")
elseif("${CMAKE_SYSTEM_NAME}" STREQUAL "Linux")
        set(OS_LINUX True)
        add_definitions(-D_GNU_SOURCE)
        message(STATUS " Compiling for Linux... ")
elseif("${CMAKE_SYSTEM_NAME}" STREQUAL "CYGWIN" OR "${CMAKE_SYSTEM_NAME}" STREQUAL "MSYS" OR "${CMAKE_SYSTEM_NAME}" STREQUAL "Windows")
        set(OS_WINDOWS True)

        if(NOT "${CMAKE_INSTALL_PREFIX}" STREQUAL "/opt/netdata")
                message(FATAL_ERROR "CMAKE_INSTALL_PREFIX must be set to /opt/netdata, but it is set to ${CMAKE_INSTALL_PREFIX}")
        endif()

        if(BUILD_FOR_PACKAGING)
                set(NETDATA_RUNTIME_PREFIX "/")
        endif()

        set(BINDIR usr/bin)
        add_definitions(-D_GNU_SOURCE)

        if($ENV{CLION_IDE})
                # clion needs these to find the includes
                if("${CMAKE_SYSTEM_NAME}" STREQUAL "MSYS" OR "${CMAKE_SYSTEM_NAME}" STREQUAL "Windows")
                        if("$ENV{MSYSTEM}" STREQUAL "MSYS")
                                include_directories(c:/msys64/usr/include)
                                include_directories(c:/msys64/usr/include/w32api)
                        elseif("$ENV{MSYSTEM}" STREQUAL "MINGW64")
                                include_directories(c:/msys64/mingw64/include)
                        elseif("$ENV{MSYSTEM}" STREQUAL "UCRT64")
                                include_directories(c:/msys64/ucrt64/include)
                        endif()
                endif()
        endif()

        message(STATUS " Compiling for Windows (${CMAKE_SYSTEM_NAME}, MSYSTEM=$ENV{MSYSTEM})... ")
else()
        message(FATAL_ERROR "Unknown/unsupported platform: ${CMAKE_SYSTEM_NAME} (Supported platforms: FreeBSD, Linux, macOS, Windows)")
endif()

# This is intended to make life easier for developers who are working on one
# specific feature.
#
# NOTE: DO NOT USE THIS OPTION FOR PRODUCTION BUILDS.
option(DEFAULT_FEATURE_STATE "Specify the default state for most optional features" True)
mark_as_advanced(DEFAULT_FEATURE_STATE)

# High-level features
option(ENABLE_ACLK "Enable Netdata Cloud support (ACLK)" ${DEFAULT_FEATURE_STATE})
option(ENABLE_CLOUD "Enable Netdata Cloud by default at runtime" ${DEFAULT_FEATURE_STATE})
option(ENABLE_ML "Enable machine learning features" ${DEFAULT_FEATURE_STATE})
option(ENABLE_DBENGINE "Enable dbengine metrics storage" True)

# Data collection plugins
option(ENABLE_PLUGIN_GO "Enable metric collectors written in Go" ${DEFAULT_FEATURE_STATE})

cmake_dependent_option(ENABLE_PLUGIN_APPS "Enable per-process resource usage monitoring" ${DEFAULT_FEATURE_STATE} "NOT OS_WINDOWS" False)
cmake_dependent_option(ENABLE_PLUGIN_CUPS "Enable CUPS monitoring" ${DEFAULT_FEATURE_STATE} "NOT OS_WINDOWS" False)

cmake_dependent_option(ENABLE_PLUGIN_FREEIPMI "Enable IPMI monitoring" ${DEFAULT_FEATURE_STATE} "OS_LINUX OR OS_FREEBSD" False)

cmake_dependent_option(ENABLE_PLUGIN_CGROUP_NETWORK "Enable Linux CGroup network usage monitoring" ${DEFAULT_FEATURE_STATE} "OS_LINUX" False)
cmake_dependent_option(ENABLE_PLUGIN_DEBUGFS "Enable Linux DebugFS metric collection" ${DEFAULT_FEATURE_STATE} "OS_LINUX" False)
cmake_dependent_option(ENABLE_PLUGIN_EBPF "Enable Linux eBPF metric collection" ${DEFAULT_FEATURE_STATE} "OS_LINUX" False)
cmake_dependent_option(ENABLE_LEGACY_EBPF_PROGRAMS "Enable eBPF programs for kernels without BTF support" True "ENABLE_PLUGIN_EBPF" False)
mark_as_advanced(ENABLE_LEGACY_EBPF_PROGRAMS)
cmake_dependent_option(ENABLE_PLUGIN_LOCAL_LISTENERS "Enable local listening socket tracking (including service auto-discovery support)" ${DEFAULT_FEATURE_STATE} "OS_LINUX" False)
cmake_dependent_option(ENABLE_PLUGIN_NETWORK_VIEWER "Enable network viewer functionality" ${DEFAULT_FEATURE_STATE} "OS_LINUX" False)
cmake_dependent_option(ENABLE_PLUGIN_NFACCT "Enable Linux NFACCT metric collection" ${DEFAULT_FEATURE_STATE} "OS_LINUX" False)
cmake_dependent_option(ENABLE_PLUGIN_PERF "Enable Linux performance counter monitoring" ${DEFAULT_FEATURE_STATE} "OS_LINUX" False)
cmake_dependent_option(ENABLE_PLUGIN_SLABINFO "Enable Linux kernel SLAB allocator monitoring" ${DEFAULT_FEATURE_STATE} "OS_LINUX" False)
cmake_dependent_option(ENABLE_PLUGIN_SYSTEMD_JOURNAL "Enable systemd journal log collection" ${DEFAULT_FEATURE_STATE} "OS_LINUX" False)
cmake_dependent_option(ENABLE_PLUGIN_XENSTAT "Enable Xen domain monitoring" ${DEFAULT_FEATURE_STATE} "OS_LINUX" False)

# Metrics exporters
option(ENABLE_EXPORTER_PROMETHEUS_REMOTE_WRITE "Enable exporting to Prometheus via remote write API" ${DEFAULT_FEATURE_STATE})
option(ENABLE_EXPORTER_MONGODB "Enable exporting to MongoDB" ${DEFAULT_FEATURE_STATE})

# Vendoring
option(ENABLE_BUNDLED_JSONC "Force use of a vendored copy of JSON-C" False)
option(ENABLE_BUNDLED_YAML "Force use of a vendored copy of libyaml" False)
option(ENABLE_BUNDLED_PROTOBUF "Use a vendored copy of protobuf" False)

# Experimental features
option(ENABLE_WEBRTC "Enable WebRTC dashboard communications (experimental)" False)
mark_as_advanced(ENABLE_WEBRTC)
option(ENABLE_H2O "Enable H2O web server (experimental)" True)
mark_as_advanced(ENABLE_H2O)

# Other optional functionality
option(ENABLE_SENTRY "Build with Sentry Native crash reporting" False)
mark_as_advanced(ENABLE_SENTRY)

option(BUILD_FOR_PACKAGING "Include component files for native packages" False)
mark_as_advanced(BUILD_FOR_PACKAGING)

cmake_dependent_option(FORCE_LEGACY_LIBBPF "Force usage of libbpf 0.0.9 instead of the latest version." False "ENABLE_PLUGIN_EBPF" False)
mark_as_advanced(FORCE_LEGACY_LIBBPF)

if(ENABLE_ACLK OR ENABLE_EXPORTER_PROMETHEUS_REMOTE_WRITE)
        set(NEED_PROTOBUF True)
else()
        set(NEED_PROTOBUF False)
endif()

if(ENABLE_PLUGIN_GO)
    include(NetdataGoTools)

    find_min_go_version("${CMAKE_SOURCE_DIR}/src/go")

    find_package(Go "${MIN_GO_VERSION}" REQUIRED)
endif()

if(ENABLE_PLUGIN_GO)
    set(NEED_NDSUDO TRUE)
else()
    set(NEED_NDSUDO FALSE)
endif()

if(ENABLE_WEBRTC)
        include(FetchContent)
        include(NetdataFetchContentExtra)

        # ignore debhelper
        set(FETCHCONTENT_FULLY_DISCONNECTED Off)

        set(PREFER_SYSTEM_LIB True)
        set(NO_MEDIA True)
        set(NO_WEBSOCKET True)

        set(HAVE_LIBDATACHANNEL True)

        FetchContent_Declare(libdatachannel
            GIT_REPOSITORY https://github.com/paullouisageneau/libdatachannel.git
            GIT_TAG v0.20.1
            CMAKE_ARGS ${NETDATA_PROPAGATE_TOOLCHAIN_ARGS}
        )
        FetchContent_MakeAvailable(libdatachannel)
endif()

if(NEED_PROTOBUF)
        include(NetdataProtobuf)

        if(ENABLE_BUNDLED_PROTOBUF)
                netdata_bundle_protobuf()
        endif()
endif()

set(PKG_FILES_PATH "${CMAKE_SOURCE_DIR}/packaging/cmake/pkg-files")

if(ENABLE_PLUGIN_EBPF)
        include(NetdataLibBPF)
        include(NetdataEBPFCORE)

        if(NOT OS_LINUX)
            message(FATAL_ERROR "The eBPF plugin is not supported on non-Linux systems")
        endif()

        netdata_bundle_libbpf()
        netdata_fetch_ebpf_co_re()
endif()

#
# Libm
#

# checks link with cmake required libs
cmake_policy(SET CMP0075 NEW)

include(CheckFunctionExists)

check_function_exists(log10 HAVE_LOG10)
if(NOT HAVE_LOG10)
        unset(HAVE_LOG10 CACHE)
        list(APPEND CMAKE_REQUIRED_LIBRARIES m)
        check_function_exists(log10 HAVE_LOG10)
        if(HAVE_LOG10)
                set(LINK_LIBM True)
        else()
                message(FATAL_ERROR "Can not use log10 with/without libm.")
        endif()
endif()

#
# Custom Modules
#

include(NetdataJSONC)
include(NetdataYAML)

if(ENABLE_LEGACY_EBPF_PROGRAMS)
        include(NetdataEBPFLegacy)
endif()

if(ENABLE_SENTRY)
        include(NetdataSentry)
endif()

#
# Checks from custom modules
#

netdata_detect_jsonc()
netdata_detect_libyaml()

if(ENABLE_LEGACY_EBPF_PROGRAMS)
        netdata_fetch_legacy_ebpf_code()
endif()

if(ENABLE_SENTRY)
        netdata_bundle_sentry()
endif()

#
# check include files
#

include(CheckIncludeFile)

check_include_file("netinet/in.h" HAVE_NETINET_IN_H)
check_include_file("resolv.h" HAVE_RESOLV_H)
check_include_file("netdb.h" HAVE_NETDB_H)
check_include_file("sys/prctl.h" HAVE_SYS_PRCTL_H)
check_include_file("sys/stat.h" HAVE_SYS_STAT_H)
check_include_file("sys/vfs.h" HAVE_SYS_VFS_H)
check_include_file("sys/statfs.h" HAVE_SYS_STATFS_H)
check_include_file("linux/magic.h" HAVE_LINUX_MAGIC_H)
check_include_file("sys/mount.h" HAVE_SYS_MOUNT_H)
check_include_file("sys/statvfs.h" HAVE_SYS_STATVFS_H)
check_include_file("inttypes.h" HAVE_INTTYPES_H)
check_include_file("stdint.h" HAVE_STDINT_H)
check_include_file("sys/capability.h" HAVE_SYS_CAPABILITY_H)
check_include_file("arpa/inet.h" HAVE_ARPA_INET_H)
check_include_file("netinet/tcp.h" HAVE_NETINET_TCP_H)
check_include_file("sys/ioctl.h" HAVE_SYS_IOCTL_H)
check_include_file("grp.h" HAVE_GRP_H)
check_include_file("pwd.h" HAVE_PWD_H)

=== debian/changelog ===
netdata (1.47.2-1) sid; urgency=medium

  * Uploading to sid.
  * Merging upstream version 1.47.2.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Mon, 30 Sep 2024 06:58:08 +0200

netdata (1.47.1-1) sid; urgency=medium

  * Uploading to sid.
  * Merging upstream version 1.47.1.
  * Updating chown in postinst for /usr/lib to /usr/libexec move in
    netdata 1.47 (Closes: #1079714).
  * Updating lintian overrides for /usr/lib to /usr/libexec move in
    netdata 1.47.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Tue, 10 Sep 2024 22:17:14 +0200

netdata (1.47.0-1) sid; urgency=medium

  * Uploading to sid.
  * Merging upstream version 1.47.0.
  * Updating apt command in README.Debian for newer apt.
  * Removing manual python3-six depends, not needed anymore (Closes:
    #1061684).
  * Removing use-system-exim4.patch, not needed anymore.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Mon, 26 Aug 2024 10:15:55 +0200

netdata (1.46.3-2) experimental; urgency=medium

  * Uploading to experimental.
  * Correcting watch file.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Thu, 25 Jul 2024 06:39:50 +0200

netdata (1.46.3-1) experimental; urgency=medium

  * Uploading to experimental.
  * Merging upstream version 1.46.3.
  * Updating to standards-version 4.7.0.
  * Listing excluded files in copyright.
  * Refreshing use-system-python.patch.
  * Refreshing use-system-exim4.patch.
  * Refreshing use-python3.patch.
  * Refreshing send-email.patch.
  * Removing fix-FTCBFS.patch, not neded anymore.
  * Updating packaging for upstreams move to cmake.
  * Adding newly required build-depends.
  * Temporarily disabling some plugins to fix FTBFS and no-network during
    build.
  * Updating paths for upstreams /usr/lib/netdata to /usr/libexec/netdata
    transition.
  * Updating netdata-core.install for newly added files.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Wed, 24 Jul 2024 13:04:39 +0200

## netdata 1.47.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -330,9 +330,10 @@
 check_include_file("sys/statvfs.h" HAVE_SYS_STATVFS_H)
 check_include_file("inttypes.h" HAVE_INTTYPES_H)
 check_include_file("stdint.h" HAVE_STDINT_H)
-check_include_file("sys/capability.h" HAVE_SYS_CAPABILITY_H)
 check_include_file("arpa/inet.h" HAVE_ARPA_INET_H)
 check_include_file("netinet/tcp.h" HAVE_NETINET_TCP_H)
 check_include_file("sys/ioctl.h" HAVE_SYS_IOCTL_H)
 check_include_file("grp.h" HAVE_GRP_H)
 check_include_file("pwd.h" HAVE_PWD_H)
+check_include_file("net/if.h" HAVE_NET_IF_H)
+check_include_file("poll.h" HAVE_POLL_H)

=== packaging/repoconfig/CMakeLists.txt ===
# SPDX-License-Identifier: GPL-3.0-or-later

cmake_minimum_required(VERSION 3.16.0...3.30)

list(APPEND RHEL_DISTROS centos centos-stream rocky almalinux cloudlinux)
list(APPEND SUSE_DISTROS opensuse-leap opensuse-tumbleweed)
list(APPEND RPM_DISTROS rhel opensuse ol amzn fedora)
list(APPEND DEB_DISTROS debian ubuntu)

set(DEB_GPG_KEY_SOURCE "https://repo.netdata.cloud/netdatabot.gpg.key")

set(PACKAGE_VERSION 3)
set(PACKAGE_RELEASE 4)

set(CPACK_THREADS 0)
set(CPACK_STRIP_FILES NO)
set(CPACK_PACKAGE_INSTALL_DIRECTORY "netdata")
set(CPACK_PACKAGE_DIRECTORY "${CMAKE_BINARY_DIR}/packages")
set(CPACK_PACKAGING_INSTALL_PREFIX "/")
set(CPACK_PACKAGE_VENDOR "Netdata Inc.")
set(CPACK_COMPONENT_NETDATA-REPO_PACKAGE_DESCRIPTION "Configuration for the official Netdata Stable package repository.")
set(CPACK_COMPONENT_NETDATA-REPO-EDGE_PACKAGE_DESCRIPTION "Configuration for the official Netdata Edge package repository.")

project(netdata-repoconfig VERSION "${PACKAGE_VERSION}.${PACKAGE_RELEASE}"
        DESCRIPTION "Repository configuration for Netdata’s official native packages."
        HOMEPAGE_URL "https://www.netdata.cloud/"
        LANGUAGES NONE)

function(extract_release_item _variable _item)
  if(DEFINED "${_variable}")
    return()
  endif()

  if(DEFINED OS_RELEASE_FILE)
  else()
    message(CHECK_START "Searching for os-release file")
    find_file(OS_RELEASE_FILE os-release PATHS /etc /lib /usr/lib NO_DEFAULT_PATH)
    if(${OS_RELEASE_FILE} STREQUAL "OS_RELEASE_FILE-NOTFOUND")
      message(CHECK_FAIL "failed")
      message(FATAL_ERROR "Could not find os-release file")
    endif()

    message(CHECK_PASS "${OS_RELEASE_FILE}")
  endif()

  message(CHECK_START "Extracting ${_item} from ${OS_RELEASE_FILE}")
  execute_process(COMMAND sh -c ". ${OS_RELEASE_FILE} && printf %s $${_item}"
                  RESULT_VARIABLE _result
                  OUTPUT_VARIABLE _output)

  if(NOT ${_result} EQUAL 0)
    message(CHECK_FAIL "failed to parse ${OS_RELEASE_FILE}")
    return()
  elseif(${_output} STREQUAL "")
    message(CHECK_FAIL "variable ${_item} not defined in ${OS_RELEASE_FILE}")
    return()
  endif()

  message(CHECK_PASS ${_output})
  set(${_variable} ${_output} PARENT_SCOPE)
endfunction()

function(require_command _variable _cmd)
  if(DEFINED ${_variable})
    return()
  endif()

  message(CHECK_START "Looking for ${_cmd}")

  find_program(_result_${_cmd} ${_cmd})

  if(${_result_${_cmd}} STREQUAL "_result_${_cmd}-NOTFOUND")
    message(CHECK_FAIL "failed")
    message(FATAL_ERROR "Unable to find required command: ${_cmd}")
  endif()

  message(CHECK_PASS "${_result_${_cmd}}")
  set(${_variable} ${_result_${_cmd}} PARENT_SCOPE)
endfunction()

if(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
  extract_release_item("DISTRO" ID)

  if(NOT DEFINED DISTRO)
    message(FATAL_ERROR "Failed to auto-detect distro ID")
  endif()

  extract_release_item(DISTRO_VERSION VERSION_ID)

  if(NOT DEFINED DISTRO_VERSION)
    message(FATAL_ERROR "Failed to auto-detect distro version ID.")
  endif()
else()
  message(FATAL_ERROR "Repository configuration packages can only be built on Linux")
endif()

if(${DISTRO} IN_LIST RHEL_DISTROS)
  set(DISTRO "rhel")
elseif(${DISTRO} STREQUAL "opensuse-leap")
  set(DISTRO "opensuse")
elseif(${DISTRO} STREQUAL "opensuse-tumbleweed")
  set(DISTRO "opensuse")
  set(DISTRO_VERSION "tumbleweed")
endif()

if(${DISTRO} IN_LIST DEB_DISTROS)
  extract_release_item(SUITE VERSION_CODENAME)

  if(NOT DEFINED SUITE)
    message(FATAL_ERROR "Failed to determine version codename")
  endif()

  require_command(DPKG dpkg)
  require_command(CURL curl)
  require_command(GPG gpg)

  set(DIST_NAME ${DISTRO})
  message(STATUS "Generating stable repository configuration for ${DISTRO} ${SUITE}")
  set(VARIANT stable)
  configure_file(netdata.sources.in netdata.sources @ONLY)
  message(STATUS "Generating edge repository configuration for ${DISTRO} ${SUITE}")
  set(VARIANT edge)
  configure_file(netdata.sources.in netdata-edge.sources @ONLY)
  message(STATUS "Preparing changelogs")
  set(PKG_NAME netdata-repo)
  file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/netdata-repo)
  configure_file(deb.changelog netdata-repo/changelog @ONLY)
  set(PKG_NAME netdata-repo-edge)
  file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/netdata-repo-edge)
  configure_file(deb.changelog netdata-repo-edge/changelog @ONLY)

  install(FILES ${CMAKE_BINARY_DIR}/netdata.sources
          DESTINATION etc/apt/sources.list.d
          COMPONENT netdata-repo)
  install(FILES ${CMAKE_BINARY_DIR}/netdata-edge.sources
          DESTINATION etc/apt/sources.list.d
          COMPONENT netdata-repo-edge)

  add_custom_command(OUTPUT ${CMAKE_BINARY_DIR}/netdatabot.gpg.key
                     COMMENT "Fetch GPG key from ${DEB_GPG_KEY_SOURCE}"
                     COMMAND ${CURL} -f -L -o ${CMAKE_BINARY_DIR}/netdatabot.gpg.key ${DEB_GPG_KEY_SOURCE})

  add_custom_command(OUTPUT ${CMAKE_BINARY_DIR}/netdata.gpg
                     COMMENT "Dearmor ${CMAKE_BINARY_DIR}/netdatabot.gpg.key"
                     DEPENDS ${CMAKE_BINARY_DIR}/netdatabot.gpg.key
                     COMMAND ${GPG} --dearmor --output ${CMAKE_BINARY_DIR}/netdata.gpg ${CMAKE_BINARY_DIR}/netdatabot.gpg.key)
  add_custom_target(dearmor_gpg_key
                    ALL
                    COMMENT "Dearmor ${CMAKE_BINARY_DIR}/netdatabot.gpg.key"
                    DEPENDS ${CMAKE_BINARY_DIR}/netdata.gpg)

  install(FILES ${CMAKE_BINARY_DIR}/netdata.gpg
          DESTINATION usr/share/keyrings
          RENAME netdata-archive-keyring.gpg
          PERMISSIONS OWNER_READ GROUP_READ WORLD_READ
          COMPONENT netdata-repo)

  install(FILES ${CMAKE_BINARY_DIR}/netdata.gpg
          DESTINATION usr/share/keyrings
          RENAME netdata-archive-keyring.gpg
          PERMISSIONS OWNER_READ GROUP_READ WORLD_READ
          COMPONENT netdata-repo-edge)

  set(CPACK_DEB_COMPONENT_INSTALL YES)
  set(CPACK_DEBIAN_DEBUGINFO_PACKAGE NO)
  set(CPACK_DEBIAN_PACKAGE_SHLIBDEPS NO)
  set(CPACK_DEBIAN_ENABLE_COMPONENT_DEPENDS YES)
  set(CPACK_DEBIAN_FILE_NAME DEB-DEFAULT)
  set(CPACK_DEBIAN_PACKAGE_MAINTAINER "Netdata Builder <bot@netdata.cloud>")
  set(CPACK_DEBIAN_PACKAGE_ARCHITECTURE "all")
  set(CPACK_DEBIAN_PACKAGE_DEPENDS "debian-keyring, gnupg")
  set(CPACK_DEBIAN_PACKAGE_SECTION "net")
  set(CPACK_DEBIAN_PACKAGE_VERSION "${PACKAGE_VERSION}")
  set(CPACK_DEBIAN_PACKAGE_RELEASE "${PACKAGE_RELEASE}")
  set(CPACK_DEBIAN_NETDATA-REPO_PACKAGE_NAME "netdata-repo")
  set(CPACK_DEBIAN_NETDATA-REPO-EDGE_PACKAGE_NAME "netdata-repo-edge")
  set(CPACK_DEBIAN_NETDATA-REPO_PACKAGE_CONFLICTS "netdata-repo-edge")
  set(CPACK_DEBIAN_NETDATA-REPO-EDGE_PACKAGE_CONFLICTS "netdata-repo")
  set(CPACK_DEBIAN_NETDATA-REPO_PACKAGE_CONTROL_EXTRA "${CMAKE_BINARY_DIR}/netdata-repo/changelog")
  set(CPACK_DEBIAN_NETDATA-REPO-EDGE_PACKAGE_CONTROL_EXTRA "${CMAKE_BINARY_DIR}/netdata-repo-edge/changelog")
elseif(${DISTRO} IN_LIST RPM_DISTROS)
  require_command(RPM rpm)

  if(${RPM} STREQUAL "RPM-NOTFOUND")
    message(FATAL_ERROR "Unable to find rpm, which is required for RPM package builds.")
  endif()

  set(REPO_CFG_PATH "yum.repos.d")
  set(REPO_ID "dnf")
  set(DIST_NAME "${DISTRO}")
  set(DIST_VERSION "$releasever")

  if(${DISTRO} STREQUAL "amzn")
    set(DIST_NAME "amazonlinux")
    if(${DISTRO_VERSION} VERSION_EQUAL 2)
      # Nothing to do in this case, defaults work here.
    elseif(${DISTRO_VERSION} VERSION_EQUAL 2023)
      set(DIST_VERSION "2023")
    else()
      message(FATAL_ERROR "Unsupported version of Amazon Linux: ${DISTRO_VERSION}")
    endif()
  elseif(${DISTRO} STREQUAL "opensuse")
    set(REPO_CFG_PATH "zypp/repos.d")
    set(REPO_ID "zypp")
    set(DIST_NAME "opensuse")
  elseif(${DISTRO} STREQUAL "rhel")
    set(DIST_NAME "el")

    if(${DISTRO_VERSION} VERSION_LESS_EQUAL 8)
      set(CPACK_RPM_PACKAGE_REQUIRES "yum-plugin-priorities, epel-release")
    else()
      set(CPACK_RPM_PACKAGE_REQUIRES "epel-release")
    endif()
  endif()

  message(STATUS "Generating stable repository configuration for ${DISTRO} ${DISTRO_VERSION}")
  set(VARIANT stable)
  configure_file(netdata.repo.${REPO_ID} netdata.repo @ONLY)
  message(STATUS "Generating edge repository configuration for ${DISTRO} ${DISTRO_VERSION}")
  set(VARIANT edge)
  configure_file(netdata.repo.${REPO_ID} netdata-edge.repo @ONLY)

  install(FILES ${CMAKE_BINARY_DIR}/netdata.repo
          COMPONENT netdata-repo
          DESTINATION etc/${REPO_CFG_PATH})
  install(FILES ${CMAKE_BINARY_DIR}/netdata-edge.repo
          COMPONENT netdata-repo-edge
          DESTINATION etc/${REPO_CFG_PATH})

  set(CPACK_RPM_COMPONENT_INSTALL ON)
  set(CPACK_RPM_PACAKGE_AUTOREQPROV OFF)
  set(CPACK_RPM_DEBUGINFO_PACKAGE OFF)
  set(CPACK_RPM_PACKAGE_LICENSE "GPLv2")
  set(CPACK_RPM_PACKAGE_GROUP "System Environment/Base")
  set(CPACK_RPM_EXCLUDE_FROM_AUTO_FILELIST "")
  set(CPACK_RPM_PACKAGE_ARCHITECTURE "noarch")
  set(CPACK_RPM_PACKAGE_VERSION "${PACKAGE_VERSION}")
  set(CPACK_RPM_PACKAGE_RELEASE "${PACKAGE_RELEASE}")
  set(CPACK_RPM_PACKAGE_CHANGELOG "${CMAKE_SOURCE_DIR}/rpm.changelog")
  set(CPACK_RPM_NETDATA-REPO_FILE_NAME "netdata-repo-${PACKAGE_VERSION}-${PACKAGE_RELEASE}.noarch.rpm")
  set(CPACK_RPM_NETDATA-REPO_PACKAGE_NAME "netdata-repo")
  set(CPACK_RPM_NETDATA-REPO_PACAKGE_CONFLICTS "netdata-repo-edge")
  set(CPACK_RPM_NETDATA-REPO-EDGE_FILE_NAME "netdata-repo-edge-${PACKAGE_VERSION}-${PACKAGE_RELEASE}.noarch.rpm")
  set(CPACK_RPM_NETDATA-REPO-EDGE_PACKAGE_NAME "netdata-repo-edge")
  set(CPACK_RPM_NETDATA-REPO-EDGE_PACKAGE_CONFLICTS "netdata-repo")
else()
  message(FATAL_ERROR "Unsupported distribution ${DISTRO} ${DISTRO_VERSION}")
endif()

include(CPack)

=== debian/changelog ===
netdata (1.47.5-1) sid; urgency=medium

  * Uploading to sid.
  * Merging upstream version 1.47.5.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Sat, 09 Nov 2024 09:26:54 +0100

=== debian/control ===
Source: netdata
Section: net
Priority: optional
Maintainer: Daniel Baumann <daniel.baumann@progress-linux.org>
Uploaders:
 Lennart Weller <lhw@ring0.de>,
 Federico Ceratto <federico@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 dh-apache2,
 libcap-dev,
 libcups2-dev,
 libelf-dev,
 libh2o-dev-common,
 libipmimonitoring-dev,
 libjson-c-dev,
 libjudy-dev,
 liblz4-dev,
 libmnl-dev,
 libnetfilter-acct-dev,
 libprotobuf-dev,
 libsnappy-dev,
 libssl-dev,
 libsystemd-dev,
 libuv1-dev,
 libyaml-dev,
 pkg-config,
 protobuf-compiler,
 uuid-dev,
 zlib1g-dev,
Rules-Requires-Root: no
Standards-Version: 4.7.0
Homepage: https://www.netdata.cloud
Vcs-Browser: https://git.progress-linux.org/users/daniel.baumann/debian/packages/netdata
Vcs-Git: https://git.progress-linux.org/users/daniel.baumann/debian/packages/netdata

Package: netdata
Section: net
Architecture: all
Depends:
 netdata-core,
 netdata-plugins-bash,
 netdata-web,
 ${misc:Depends},
Recommends:
 netdata-plugins-python,
Description: real-time performance monitoring (metapackage)
 Netdata is distributed, real-time, performance and health monitoring for
 systems and applications. It provides insights of everything happening on the
 systems it runs using interactive web dashboards.
 .
 It can run autonomously without any third party components or it can be
 integrated to existing monitoring tool chains (Prometheus, Graphite,
 OpenTSDB, Kafka, Grafana, etc).
 .
 This package is a metapackage depending on the typical netdata components.

Package: netdata-apache2
Section: net
Architecture: all
Depends:
 apache2,
 netdata-core (>= ${source:Version}),
 netdata-web (>= ${source:Version}),
 ${misc:Depends},
Enhances:
 netdata-core,
Description: real-time performance monitoring (apache integration)
 Netdata is distributed, real-time, performance and health monitoring for
 systems and applications. It provides insights of everything happening on the
 systems it runs using interactive web dashboards.
 .
 Netdata includes its own embedded webserver, by default listening on localhost
 only. To make netdata available to other users, a dedicated webserver such as
 apache should be used (with authentication and encryption).
 .
 This package contains the integration for the apache HTTP server.

Package: netdata-core
Section: net
Architecture: linux-any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 libcap2-bin,
 lsb-base,
 passwd,
 sse2-support [i386],
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 curl,
Suggests:
 apcupsd,
 iproute2,
 iw,
 lm-sensors,
 nc,
Breaks:
 netdata-core-no-sse (<< 1.44),
Replaces:
 netdata-core-no-sse,
Description: real-time performance monitoring (core)
 Netdata is distributed, real-time, performance and health monitoring for
 systems and applications. It provides insights of everything happening on the
 systems it runs using interactive web dashboards.
 .
 This package contains the minimal core build with SSE2 optimizations for
 current systems.

Package: netdata-core-no-sse
Section: net
Architecture: i386
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
Description: real-time performance monitoring (transitional package)
 Package to ease upgrading from older netdata-core-no-sse package to the new
 netdata-core package.
 .
 This package can be purged at anytime once the netdata-core package has been
 installed.

Package: netdata-plugins-bash
Section: net
Architecture: all
Multi-Arch: foreign
Depends:
 netdata-core (>= ${source:Version}),
 ${misc:Depends},
Suggests:
 fping,
Provides:
 netdata-plugins,
Enhances:
 netdata-core,
Description: real-time performance monitoring (bash plugins)
 Netdata is distributed, real-time, performance and health monitoring for
 systems and applications. It provides insights of everything happening on the
 systems it runs using interactive web dashboards.
 .
 This package contains the plugins using bash.

Package: netdata-plugins-python
Section: net
Architecture: all
Multi-Arch: foreign
Depends:
 netdata-core (>= ${source:Version}),
 python3,
 python3-urllib3 (>= 1.22),
 python3-yaml,
 ${misc:Depends},
Suggests:
 python3-psycopg2,
 python3-pymysql,
 python3-requests,
Provides:
 netdata-plugins,
Enhances:
 netdata-core,
Description: real-time performance monitoring (python plugins)
 Netdata is distributed, real-time, performance and health monitoring for
 systems and applications. It provides insights of everything happening on the
 systems it runs using interactive web dashboards.
 .
 This package contains the plugins using python.

Package: netdata-web
Section: net
Architecture: all
Depends:
 fonts-font-awesome,
 libjs-bootstrap,
 netdata-core (>= ${source:Version}),
 ${misc:Depends},
Enhances:
 netdata-core,
Description: real-time performance monitoring (web)
 Netdata is distributed, real-time, performance and health monitoring for
 systems and applications. It provides insights of everything happening on the
 systems it runs using interactive web dashboards.
 .
 This package contains the web frontend.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/architecture.mk

ifeq ($(DEB_HOST_ARCH),s390x)
export DEB_CFLAGS_MAINT_APPEND  = -Wall -O2
else
export DEB_CFLAGS_MAINT_APPEND  = -Wall -O3
endif

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh ${@} --with apache2

override_dh_auto_configure:
# Netdata Cloud support (ACLK)
# Netdata Cloud by default at runtime
# metric collectors written in Go
# H2O web server (experimental)
# eBPF programs for kernels without BTF support
# machine learning features
# Linux eBPF metric collection
# Xen domain monitoring
	dh_auto_configure -- \
		-DENABLE_ACLK:BOOL=OFF \
		-DENABLE_CLOUD:BOOL=OFF \
		-DENABLE_PLUGIN_GO:BOOL=OFF \
		-DENABLE_H2O:BOOL=OFF \
		-DENABLE_LEGACY_EBPF_PROGRAMS:BOOL=OFF \
		-DENABLE_ML:BOOL=OFF \
		-DENABLE_PLUGIN_EBPF:BOOL=OFF \
		-DENABLE_PLUGIN_XENSTAT=OFF \
		-DCMAKE_INSTALL_PREFIX:PATH=/

execute_after_dh_auto_install:
	# Removing unused files
	rm -f debian/tmp/etc/netdata/.install-type
	rm -f debian/tmp/usr/libexec/netdata/install-service.sh
	rm -f debian/tmp/usr/lib/netdata/conf.d/netdata-updater.conf
	rm -f debian/tmp/usr/libexec/netdata/netdata-updater.sh
	rm -rf debian/tmp/usr/lib/netdata/system

	# Building without aws kinesis backend (needs aws sdk)
	rm -f debian/tmp/usr/lib/netdata/conf.d/aws_kinesis.conf

override_dh_install-arch:
	find debian/tmp -name .keep -delete

	# Copy architecture dependent plugins
	mkdir -p debian/netdata-core/etc/netdata
	cp debian/local/netdata/netdata.conf debian/netdata-core/etc/netdata
	touch debian/netdata-core/etc/netdata/.opt-out-from-anonymous-statistics

	mkdir -p debian/netdata-core/usr/libexec/netdata/plugins.d
	for plugin in cgroup-network apps.plugin nfacct.plugin perf.plugin slabinfo.plugin; \
	do \
		cp debian/tmp/usr/libexec/netdata/plugins.d/$${plugin} \
		   debian/netdata-core/usr/libexec/netdata/plugins.d; \
	done

	dh_install -a

override_dh_install-indep:
	find debian/tmp -name .keep -delete

	dh_install -i

	# Move architecture dependent plugins
	mkdir -p debian/netdata-core/usr/libexec/netdata/plugins.d
	for plugin in cgroup-network apps.plugin nfacct.plugin perf.plugin slabinfo.plugin; \
	do \
		mv -f debian/netdata-plugins-bash/usr/libexec/netdata/plugins.d/$${plugin} \
		   debian/netdata-core/usr/libexec/netdata/plugins.d; \
	done

	mkdir -p debian/netdata-plugins-python/usr/libexec/netdata/plugins.d
	for plugin in python.d.plugin; \
	do \
		mv debian/netdata-plugins-bash/usr/libexec/netdata/plugins.d/$${plugin} \
		   debian/netdata-plugins-python/usr/libexec/netdata/plugins.d; \
	done

	# Setting package version (update check)
	echo $(VERSION) > debian/netdata-web/usr/share/netdata/web/version.txt

override_dh_installsystemd:
	dh_installsystemd -p netdata-core --name=netdata
	dh_installsystemd --remaining-packages

override_dh_installlogrotate:
	dh_installlogrotate -p netdata-core --name=netdata
	dh_installlogrotate --remaining-packages

override_dh_fixperms-arch:
	dh_fixperms -a

	# apps.plugin should only be runnable by the netdata user. It will be
	# given extra capabilities in the postinst script.
	chmod 0754 debian/netdata-core/usr/libexec/netdata/plugins.d/apps.plugin
	chmod 4754 debian/netdata-core/usr/libexec/netdata/plugins.d/perf.plugin

override_dh_fixperms-indep:
	dh_fixperms -i

	# apps.plugin should only be runnable by the netdata user. It will be
	# given extra capabilities in the postinst script.
	chmod 0644 debian/netdata-plugins-bash/usr/libexec/netdata/charts.d/*.sh
	chmod 0644 debian/netdata-plugins-bash/usr/libexec/netdata/plugins.d/*.sh.inc
	chmod 0644 debian/netdata-plugins-python/usr/libexec/netdata/python.d/*.py

=== debian/watch ===
version=4
opts="pgpmode=auto" \
https://github.com/netdata/netdata/tags .*/v?(\d\S+)\.tar\.gz

## netdata 2.0.3+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -29,6 +29,8 @@
 if(STATIC_BUILD)
     list(APPEND PKG_CONFIG_EXECUTABLE "--static")
 endif()
+
+set(CMAKE_INSTALL_MESSAGE LAZY)
 
 set(CMAKE_C_STANDARD 11)
 set(CMAKE_CXX_STANDARD 14)
@@ -118,9 +120,15 @@
         endif()
 
         set(BINDIR usr/bin)
+        set(CMAKE_RC_COMPILER_INIT windres)
+        ENABLE_LANGUAGE(RC)
+
+        SET(CMAKE_RC_COMPILE_OBJECT "<CMAKE_RC_COMPILER> <FLAGS> -O coff <DEFINES> -i <SOURCE> -o <OBJECT>")
         add_definitions(-D_GNU_SOURCE)
 
         if($ENV{CLION_IDE})
+                set(RUN_UNDER_CLION True)
+
                 # clion needs these to find the includes
                 if("${CMAKE_SYSTEM_NAME}" STREQUAL "MSYS" OR "${CMAKE_SYSTEM_NAME}" STREQUAL "Windows")
                         if("$ENV{MSYSTEM}" STREQUAL "MSYS")
@@ -147,15 +155,17 @@
 mark_as_advanced(DEFAULT_FEATURE_STATE)
 
 # High-level features
-option(ENABLE_ACLK "Enable Netdata Cloud support (ACLK)" ${DEFAULT_FEATURE_STATE})
-option(ENABLE_CLOUD "Enable Netdata Cloud by default at runtime" ${DEFAULT_FEATURE_STATE})
 option(ENABLE_ML "Enable machine learning features" ${DEFAULT_FEATURE_STATE})
 option(ENABLE_DBENGINE "Enable dbengine metrics storage" True)
+option(ENABLE_DASHBOARD "Enable local dashboard" True)
+mark_as_advanced(ENABLE_DASHBOARD)
 
 # Data collection plugins
 option(ENABLE_PLUGIN_GO "Enable metric collectors written in Go" ${DEFAULT_FEATURE_STATE})
-
-cmake_dependent_option(ENABLE_PLUGIN_APPS "Enable per-process resource usage monitoring" ${DEFAULT_FEATURE_STATE} "NOT OS_WINDOWS" False)
+option(ENABLE_PLUGIN_PYTHON "Enable metric collectors written in Python" ${DEFAULT_FEATURE_STATE})
+
+cmake_dependent_option(ENABLE_PLUGIN_APPS "Enable per-process resource usage monitoring" ${DEFAULT_FEATURE_STATE} "OS_LINUX OR OS_FREEBSD OR OS_MACOS OR OS_WINDOWS" False)
+cmake_dependent_option(ENABLE_PLUGIN_CHARTS "Enable metric collectors written in Bash" ${DEFAULT_FEATURE_STATE} "NOT OS_WINDOWS" False)
 cmake_dependent_option(ENABLE_PLUGIN_CUPS "Enable CUPS monitoring" ${DEFAULT_FEATURE_STATE} "NOT OS_WINDOWS" False)
 
 cmake_dependent_option(ENABLE_PLUGIN_FREEIPMI "Enable IPMI monitoring" ${DEFAULT_FEATURE_STATE} "OS_LINUX OR OS_FREEBSD" False)
@@ -185,7 +195,7 @@
 # Experimental features
 option(ENABLE_WEBRTC "Enable WebRTC dashboard communications (experimental)" False)
 mark_as_advanced(ENABLE_WEBRTC)
-option(ENABLE_H2O "Enable H2O web server (experimental)" True)
+option(ENABLE_H2O "Enable H2O web server (experimental)" False)
 mark_as_advanced(ENABLE_H2O)
 
 # Other optional functionality
@@ -198,11 +208,7 @@
 cmake_dependent_option(FORCE_LEGACY_LIBBPF "Force usage of libbpf 0.0.9 instead of the latest version." False "ENABLE_PLUGIN_EBPF" False)
 mark_as_advanced(FORCE_LEGACY_LIBBPF)
 
-if(ENABLE_ACLK OR ENABLE_EXPORTER_PROMETHEUS_REMOTE_WRITE)
-        set(NEED_PROTOBUF True)
-else()
-        set(NEED_PROTOBUF False)
-endif()
+set(NEED_PROTOBUF True)
 
 if(ENABLE_PLUGIN_GO)
     include(NetdataGoTools)
@@ -260,6 +266,9 @@
         netdata_bundle_libbpf()
         netdata_fetch_ebpf_co_re()
 endif()
+
+pkg_check_modules(CURL libcurl>=7.21 REQUIRED IMPORTED_TARGET)
+set(HAVE_LIBCURL TRUE)
 
 #
 # Libm
@@ -328,12 +337,3 @@
 check_include_file("linux/magic.h" HAVE_LINUX_MAGIC_H)
 check_include_file("sys/mount.h" HAVE_SYS_MOUNT_H)
 check_include_file("sys/statvfs.h" HAVE_SYS_STATVFS_H)
-check_include_file("inttypes.h" HAVE_INTTYPES_H)
-check_include_file("stdint.h" HAVE_STDINT_H)
-check_include_file("arpa/inet.h" HAVE_ARPA_INET_H)
-check_include_file("netinet/tcp.h" HAVE_NETINET_TCP_H)
-check_include_file("sys/ioctl.h" HAVE_SYS_IOCTL_H)
-check_include_file("grp.h" HAVE_GRP_H)
-check_include_file("pwd.h" HAVE_PWD_H)
-check_include_file("net/if.h" HAVE_NET_IF_H)
-check_include_file("poll.h" HAVE_POLL_H)

=== debian/changelog ===
netdata (2.0.3+dfsg-3) sid; urgency=medium

  * Uploading to unstable, not part of trixie anyway.
  * Updating vcs fields.
  * Removing myself from maintainer, orphaning package (see #1106233 for
    reasons).

 -- Daniel Baumann <mail@daniel-baumann.ch>  Wed, 21 May 2025 21:22:25 +0200

netdata (2.0.3+dfsg-2) experimental; urgency=medium

  * Updating vcs fields.
  * Trimming changelog.
  * Updating my email address.
  * Updating year in debian copyright for 2025.
  * Enabling prometheus remote write, thanks to Thomas Goirand
    <zigo@debian.org> (Closes: #1092600).

 -- Daniel Baumann <daniel@debian.org>  Wed, 21 May 2025 19:39:25 +0200

netdata (2.0.3+dfsg-1) experimental; urgency=medium

  * Merging upstream version 2.0.3+dfsg (Closes: #923993, #1042533,
    #1045145).
  * Adding upstream target in rules.
  * Removing use-system-python.patch.
  * Refreshing use-python3.patch.
  * Adding patch to use system pyaml3 directly rather than first trying
    embedded copy (that is removed in Debian).
  * Addin patch to use system python modules rather than first trying
    embedded copies (that are removed in Debian).
  * Adding patch to use system dlib.
  * Updating copyright for new upstream version.
  * Removing removed cmake build options.
  * Disabling to download and embedd dashboard binaries during built.
  * Removing netdata frontend packaging, upstream split the sources out to
    netdata-dashboard.
  * Folding netdata-core into netdata itself.
  * Updating build-depends for new upstream version.
  * Enabling machine-learning support (Closes: #1054354).
  * Including api files in netdata, later being used via netdata-
    dashboard.
  * Updating todo file.
  * Updating watch file.

 -- Daniel Baumann <daniel@debian.org>  Mon, 25 Nov 2024 18:14:34 +0100

=== debian/control ===
Source: netdata
Section: net
Priority: optional
Maintainer: Lennart Weller <lhw@ring0.de>
Uploaders:
 Federico Ceratto <federico@debian.org>,
Build-Depends:
 cmake,
 curl,
 debhelper-compat (= 13),
 libbpf-dev,
 libcap-dev,
 libcups2-dev,
 libcurl4-openssl-dev,
 libdlib-dev,
 libelf-dev,
 libh2o-dev-common,
 libipmimonitoring-dev,
 libjson-c-dev,
 libjudy-dev,
 liblz4-dev,
 libmnl-dev,
 libmosquitto-dev,
 libnetfilter-acct-dev,
 libpcre2-dev,
 libprotobuf-c-dev,
 libprotobuf-dev,
 libsnappy-dev,
 libssl-dev,
 libsystemd-dev,
 libuv1-dev,
 libwebsockets-dev,
 libyaml-dev,
 libzstd-dev,
 lm-sensors,
 pkgconf,
 protobuf-c-compiler,
 protobuf-compiler,
 python3,
 uuid-dev,
 zlib1g-dev,
Rules-Requires-Root: no
Standards-Version: 4.7.0
Homepage: https://www.netdata.cloud
Vcs-Browser: https://salsa.debian.org/debian/netdata
Vcs-Git: https://salsa.debian.org/debian/netdata.git

Package: netdata
Section: net
Architecture: linux-any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 libcap2-bin,
 lsb-base,
 passwd,
 sse2-support [i386],
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 curl,
 netdata-plugins-bash,
 netdata-plugins-python,
Suggests:
 apcupsd,
 iproute2,
 iw,
 lm-sensors,
 nc,
Breaks:
 netdata-apache2,
 netdata-core (<< 2),
 netdata-core-no-sse (<< 2),
 netdata-web,
Replaces:
 netdata-apache2,
 netdata-core,
 netdata-core-no-sse,
 netdata-web,
Description: real-time performance monitoring
 Netdata is distributed, real-time, performance and health monitoring for
 systems and applications. It provides insights of everything happening on the
 systems it runs using interactive web dashboards.
 .
 It can run autonomously without any third party components or it can be
 integrated to existing monitoring tool chains (Prometheus, Graphite,
 OpenTSDB, Kafka, Grafana, etc).

Package: netdata-core
Section: net
Architecture: all
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
Description: real-time performance monitoring (transitional package)
 Package to ease upgrading from older netdata-core package to the new
 netdata package.
 .
 This package can be purged at anytime once the netdata package has been
 installed.

Package: netdata-core-no-sse
Section: net
Architecture: i386
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
Description: real-time performance monitoring (transitional package)
 Package to ease upgrading from older netdata-core-no-sse package to the new
 netdata package.
 .
 This package can be purged at anytime once the netdata package has been
 installed.

Package: netdata-plugins-bash
Section: net
Architecture: all
Multi-Arch: foreign
Depends:
 netdata (>= ${source:Version}),
 ${misc:Depends},
Suggests:
 fping,
Provides:
 netdata-plugins,
Enhances:
 netdata,
Description: real-time performance monitoring (bash plugins)
 Netdata is distributed, real-time, performance and health monitoring for
 systems and applications. It provides insights of everything happening on the
 systems it runs using interactive web dashboards.
 .
 This package contains the plugins using bash.

Package: netdata-plugins-python
Section: net
Architecture: all
Multi-Arch: foreign
Depends:
 netdata (>= ${source:Version}),
 python3,
 python3-monotonic,
 python3-urllib3 (>= 1.22),
 python3-yaml,
 ${misc:Depends},
Suggests:
 python3-psycopg2,
 python3-pymysql,
 python3-requests,
Provides:
 netdata-plugins,
Enhances:
 netdata,
Description: real-time performance monitoring (python plugins)
 Netdata is distributed, real-time, performance and health monitoring for
 systems and applications. It provides insights of everything happening on the
 systems it runs using interactive web dashboards.
 .
 This package contains the plugins using python.

=== debian/rules ===
#!/usr/bin/make -f

VERSION := $(shell dpkg-parsechangelog | awk '/^Version: / { print $$2 }' | cut -d+ -f1)

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/architecture.mk

ifeq ($(DEB_HOST_ARCH),s390x)
export DEB_CFLAGS_MAINT_APPEND  = -Wall -O2
else
export DEB_CFLAGS_MAINT_APPEND  = -Wall -O3
endif

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh ${@}

override_dh_auto_configure:
# metric collectors written in Go
# H2O web server (experimental)
# eBPF programs for kernels without BTF support
# Linux eBPF metric collection
# Xen domain monitoring
	dh_auto_configure -- \
		-DENABLE_PLUGIN_GO:BOOL=OFF \
		-DENABLE_H2O:BOOL=OFF \
		-DENABLE_LEGACY_EBPF_PROGRAMS:BOOL=OFF \
		-DENABLE_PLUGIN_EBPF:BOOL=OFF \
		-DENABLE_PLUGIN_XENSTAT=OFF \
		-DENABLE_PROMETHEUS_REMOTE_WRITE:BOOL=ON \
		-DENABLE_DASHBOARD=OFF \
		-DCMAKE_INSTALL_PREFIX:PATH=/

execute_after_dh_auto_install:
	# Removing unused files
	rm -f debian/tmp/etc/netdata/.install-type
	rm -f debian/tmp/usr/libexec/netdata/install-service.sh
	rm -f debian/tmp/usr/lib/netdata/conf.d/netdata-updater.conf
	rm -f debian/tmp/usr/libexec/netdata/netdata-updater.sh
	rm -rf debian/tmp/usr/lib/netdata/system

	# Building without aws kinesis backend (needs aws sdk)
	rm -f debian/tmp/usr/lib/netdata/conf.d/aws_kinesis.conf

override_dh_install-arch:
	find debian/tmp -name .keep -delete

	# Copy architecture dependent plugins
	mkdir -p debian/netdata/etc/netdata
	cp debian/local/netdata/netdata.conf debian/netdata/etc/netdata
	touch debian/netdata/etc/netdata/.opt-out-from-anonymous-statistics

	mkdir -p debian/netdata/usr/libexec/netdata/plugins.d
	for plugin in cgroup-network apps.plugin nfacct.plugin perf.plugin slabinfo.plugin; \
	do \
		cp debian/tmp/usr/libexec/netdata/plugins.d/$${plugin} \
		   debian/netdata/usr/libexec/netdata/plugins.d; \
	done

	dh_install -a

override_dh_install-indep:
	find debian/tmp -name .keep -delete

	dh_install -i

	# Move architecture dependent plugins
	mkdir -p debian/netdata/usr/libexec/netdata/plugins.d
	for plugin in cgroup-network apps.plugin nfacct.plugin perf.plugin slabinfo.plugin; \
	do \
		mv -f debian/netdata-plugins-bash/usr/libexec/netdata/plugins.d/$${plugin} \
		   debian/netdata/usr/libexec/netdata/plugins.d; \
	done

	mkdir -p debian/netdata-plugins-python/usr/libexec/netdata/plugins.d
	for plugin in python.d.plugin; \
	do \
		mv debian/netdata-plugins-bash/usr/libexec/netdata/plugins.d/$${plugin} \
		   debian/netdata-plugins-python/usr/libexec/netdata/plugins.d; \
	done

override_dh_installsystemd:
	dh_installsystemd -p netdata --name=netdata
	dh_installsystemd --remaining-packages

override_dh_installlogrotate:
	dh_installlogrotate -p netdata --name=netdata
	dh_installlogrotate --remaining-packages

override_dh_fixperms-arch:
	dh_fixperms -a

	# apps.plugin should only be runnable by the netdata user. It will be
	# given extra capabilities in the postinst script.
	chmod 0754 debian/netdata/usr/libexec/netdata/plugins.d/apps.plugin
	chmod 4754 debian/netdata/usr/libexec/netdata/plugins.d/perf.plugin

override_dh_fixperms-indep:
	dh_fixperms -i

	# apps.plugin should only be runnable by the netdata user. It will be
	# given extra capabilities in the postinst script.
	chmod 0644 debian/netdata-plugins-bash/usr/libexec/netdata/charts.d/*.sh
	chmod 0644 debian/netdata-plugins-bash/usr/libexec/netdata/plugins.d/*.sh.inc
	chmod 0644 debian/netdata-plugins-python/usr/libexec/netdata/python.d/*.py

upstream:
	git clone --recursive https://github.com/netdata/netdata netdata-$(VERSION)+dfsg
	cd netdata-$(VERSION)+dfsg && git checkout -f v$(VERSION)

	# removing embedded python modules
	rm -rf netdata-$(VERSION)+dfsg/src/collectors/python.d.plugin/python_modules/pyyaml3
	rm -rf netdata-$(VERSION)+dfsg/src/collectors/python.d.plugin/python_modules/third_party
	rm -rf netdata-$(VERSION)+dfsg/src/collectors/python.d.plugin/python_modules/urllib3

	# removing embedded shared libraries
	rm -rf netdata-$(VERSION)+dfsg/src/ml/dlib
	rm -rf netdata-$(VERSION)+dfsg/src/web/server/h2o/libh2o

	# removing git metadata
	rm -rf netdata-$(VERSION)+dfsg/.git

=== debian/watch ===
version=4
opts="dversionmangle=s/\+dfsg//" \
https://github.com/netdata/netdata/tags .*/v?(\d\S+)\.tar\.gz
